diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java
index 491d6b2fa..f6b94890b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java
@@ -2,19 +2,21 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.TextureManager;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.animal.MobButterfly;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
+import org.joml.Math;
 
 import java.util.Random;
 
 public class MobRendererButterfly extends EntityRenderer<MobButterfly> {
     private static final Random sizeRandom = new Random();
+
     @Override
-    public void render(@NotNull final Tessellator tessellator, @NotNull final MobButterfly butterfly, final double x, final double y, final double z, final float yaw, final float partialTick) {
+    public void render(@NotNull final TessellatorGeneral tessellator, @NotNull final MobButterfly butterfly, final double x, final double y, final double z, final float yaw, final float partialTick) {
         // 0.45 -> 0.8
         sizeRandom.setSeed((long) butterfly.getSkinVariant() << 16);
         final float scale = 0.45f + (sizeRandom.nextFloat() * 0.35f);
@@ -23,53 +25,53 @@ public class MobRendererButterfly extends EntityRenderer<MobButterfly> {
     }
 
     @Override
-    public void renderPreview(@NotNull final Tessellator tessellator, @NotNull final MobButterfly butterfly, final double x, final double y, final double z, final float yaw, final float partialTick) {
+    public void renderPreview(@NotNull final TessellatorGeneral tessellator, @NotNull final MobButterfly butterfly, final double x, final double y, final double z, final float yaw, final float partialTick) {
         final float yRot = MathHelper.lerp(butterfly.yRotO, butterfly.yRot, partialTick);
         drawButterfly(tessellator, butterfly.tickCount, 1.25f, -yRot, x, y + 0.5, z, partialTick, this.renderDispatcher.textureManager, getTexture(butterfly));
     }
 
-    public static void drawButterfly(final Tessellator tessellator, final int ticksAlive, final float scale, final float yRot, final double x, final double y, final double z, final float partialTick, final TextureManager textureManager, final String texture) {
+    public static void drawButterfly(final TessellatorGeneral tessellator, final int ticksAlive, final float scale, final float yRot, final double x, final double y, final double z, final float partialTick, final TextureManager textureManager, final String texture) {
         textureManager.bindTexture(textureManager.loadTexture(texture));
-        GL11.glPushMatrix();
-        GL11.glTranslatef((float) x, (float) y + 0.25f, (float) z);
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-        GL11.glDisable(GL11.GL_CULL_FACE);
-        GL11.glDisable(GL11.GL_LIGHTING);
-        GL11.glScalef(0.5F * scale, 0.5F * scale, 0.5F * scale);
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate((float) x, (float) y + 0.25f, (float) z);
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.disableState(State.CULL_FACE);
+        GLRenderer.globalSetLightEnabled(false);
+        GLRenderer.modelM4f().scale(0.5F * scale, 0.5F * scale, 0.5F * scale);
 
-        GL11.glRotatef(yRot, 0, 1, 0);
+        GLRenderer.modelM4f().rotateY(Math.toRadians(yRot));
 
-        GL11.glRotatef(-22.5f, 1, 0, 0);
+        GLRenderer.modelM4f().rotateX(Math.toRadians(-22.5f));
 
         final float xOff = -0.5F;
         final float zOff = -0.5F;
 
         final float flapAngle = (MathHelper.sin(ticksAlive + partialTick) + 1) * 22.5f + 5;
 
-        GL11.glPushMatrix();
-        GL11.glRotatef(-flapAngle, 0, 0, 1);
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().rotateZ(Math.toRadians(-flapAngle));
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(xOff,       0.0D, zOff,       0,   1);
-        tessellator.addVertexWithUV(xOff + 0.5, 0.0D, zOff,       0.5, 1);
+        tessellator.addVertexWithUV(xOff, 0.0D, zOff, 0, 1);
+        tessellator.addVertexWithUV(xOff + 0.5, 0.0D, zOff, 0.5, 1);
         tessellator.addVertexWithUV(xOff + 0.5, 0.0D, zOff + 1.0, 0.5, 0);
-        tessellator.addVertexWithUV(xOff,       0.0D, zOff + 1.0, 0,   0);
+        tessellator.addVertexWithUV(xOff, 0.0D, zOff + 1.0, 0, 0);
         tessellator.draw();
-        GL11.glPopMatrix();
+        GLRenderer.popFrame();
 
-        GL11.glPushMatrix();
-        GL11.glRotatef(flapAngle, 0, 0, 1);
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().rotateZ(Math.toRadians(flapAngle));
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(xOff + 0.5, 0.0D, zOff,       0.5, 1);
-        tessellator.addVertexWithUV(xOff + 1.0, 0.0D, zOff,       1.0, 1);
+        tessellator.addVertexWithUV(xOff + 0.5, 0.0D, zOff, 0.5, 1);
+        tessellator.addVertexWithUV(xOff + 1.0, 0.0D, zOff, 1.0, 1);
         tessellator.addVertexWithUV(xOff + 1.0, 0.0D, zOff + 1.0, 1.0, 0);
         tessellator.addVertexWithUV(xOff + 0.5, 0.0D, zOff + 1.0, 0.5, 0);
         tessellator.draw();
-        GL11.glPopMatrix();
+        GLRenderer.popFrame();
 
-        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
-        GL11.glEnable(GL11.GL_CULL_FACE);
-        GL11.glEnable(GL11.GL_LIGHTING);
-        GL11.glPopMatrix();
+//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.enableState(State.CULL_FACE);
+        GLRenderer.globalSetLightEnabled(true);
+        GLRenderer.popFrame();
     }
 
     public static String getTexture(final MobButterfly butterfly) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererChicken.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererChicken.java
index df1117655..ce391d692 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererChicken.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererChicken.java
@@ -1,10 +1,10 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.core.entity.animal.MobChicken;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.models.entity.BoneTransform;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
@@ -46,6 +46,6 @@ public class MobRendererChicken extends MobRenderer<MobChicken> {
     @Override
     protected void preRenderTransform(@NotNull MobChicken entity, double x, double y, double z, float yaw, float partialTick) {
         super.preRenderTransform(entity, x, y, z, yaw, partialTick);
-        GL11.glTranslatef(0, 0.3f, 0);
+        GLRenderer.modelM4f().translate(0, 0.3f, 0);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererCreeper.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererCreeper.java
index b0c75003f..97ee97b94 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererCreeper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererCreeper.java
@@ -1,5 +1,7 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.entity.monster.MobCreeper;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.MathHelper;
@@ -18,8 +20,10 @@ public class MobRendererCreeper extends MobRenderer<MobCreeper> {
     @Override
     protected int getOverlayColor(final @NotNull MobCreeper creeper, final float brightness, final float partialTick) {
         final float step = creeper.getSwelling(partialTick);
-        if ((int)(step * 10.0f) % 2 == 0) { return 0; }
-        return Color.intToIntARGB(MathHelper.clamp((int)(step * 0.2f * 255.0f), 0, 255), 255, 255,255);
+        if ((int) (step * 10.0f) % 2 == 0) {
+            return 0;
+        }
+        return Color.intToIntARGB(MathHelper.clamp((int) (step * 0.2f * 255.0f), 0, 255), 255, 255, 255);
     }
 
     @Override
@@ -33,18 +37,18 @@ public class MobRendererCreeper extends MobRenderer<MobCreeper> {
             GL11.glLoadIdentity();
             final float _x = ticks * 0.01F;
             final float _y = ticks * 0.01F;
-            GL11.glTranslatef(_x, _y, 0.0F);
+            GLRenderer.modelM4f().translate(_x, _y, 0.0F);
             GL11.glMatrixMode(GL11.GL_MODELVIEW);
-            GL11.glEnable(GL11.GL_BLEND);
-            GL11.glColor4f(0.5f, 0.5f, 0.5f, 1.0F);
-            GL11.glDisable(GL11.GL_LIGHTING);
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.setColor4f(0.5f, 0.5f, 0.5f, 1.0F);
+            GLRenderer.globalSetLightEnabled(false);
             GL11.glBlendFunc(GL11.GL_ONE, GL11.GL_ONE);
         } else if (layer == 2) { // Reset funky powered rendering
             GL11.glMatrixMode(GL11.GL_TEXTURE);
             GL11.glLoadIdentity();
             GL11.glMatrixMode(GL11.GL_MODELVIEW);
-            GL11.glEnable(GL11.GL_LIGHTING);
-            GL11.glDisable(GL11.GL_BLEND);
+            GLRenderer.globalSetLightEnabled(true);
+            GLRenderer.disableState(State.BLEND);
             return null;
         } else {
             model = getModel("main");
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererDeer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererDeer.java
index 93a18ff0f..20c4a2338 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererDeer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererDeer.java
@@ -1,10 +1,10 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.core.entity.animal.MobDeer;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.models.entity.BoneTransform;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
@@ -21,7 +21,7 @@ public class MobRendererDeer extends MobRenderer<MobDeer> {
     @Override
     protected void preRenderTransform(@NotNull final MobDeer entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
         super.preRenderTransform(entity, x, y, z, yaw, partialTick);
-        GL11.glScalef(1.1F, 1.1F, 1.1F);
+        GLRenderer.modelM4f().scale(1.1F, 1.1F, 1.1F);
     }
 
     @Override
@@ -42,9 +42,7 @@ public class MobRendererDeer extends MobRenderer<MobDeer> {
         final float limbSwing = getLimbSwing(entity, partialTick);
         final float limbYaw = getLimbYaw(entity, partialTick);
 
-        if (entity.brainState instanceof MobDeer.SniffingBrainState) {
-            final @NotNull MobDeer.SniffingBrainState brainState = (MobDeer.SniffingBrainState) entity.brainState;
-
+        if (entity.brainState instanceof @NotNull MobDeer.SniffingBrainState brainState) {
             final float neckRotX = MathHelper.lerp(MIN_NECK_ROT_X_SNIFF, MAX_NECK_ROT_X_SNIFF, brainState.leanPercentage);
             final float headRotX = MathHelper.lerp(MIN_HEAD_ROT_X_SNIFF, MAX_HEAD_ROT_X_SNIFF, brainState.leanPercentage);
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererFireflyCluster.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererFireflyCluster.java
index ac8050f04..6c56a558b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererFireflyCluster.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererFireflyCluster.java
@@ -1,77 +1,77 @@
 package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.Lighting;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.client.render.particle.ParticleFirefly;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
 
 import java.util.ArrayList;
 import java.util.List;
 import java.util.Random;
 
 public class MobRendererFireflyCluster extends EntityRenderer<MobFireflyCluster> {
-	private final List<ParticleFirefly> fireflies = new ArrayList<>();
+    private final List<ParticleFirefly> fireflies = new ArrayList<>();
     private final Random rand = new Random(0);
-	private long lastTick;
+    private long lastTick;
 
-	public MobRendererFireflyCluster() {
-		for (int i = 0; i < 20; i++) {
-			final ParticleFirefly fx = new ParticleFirefly(WorldClient.EMPTY_WORLD, this.rand.nextFloat() - 0.5f, this.rand.nextFloat() - 0.5f, 0, 0, 0, 0, 0);
-			fx.noPhysics = true;
-			fx.setAge(this.rand.nextInt(20));
+    public MobRendererFireflyCluster() {
+        for (int i = 0; i < 20; i++) {
+            final ParticleFirefly fx = new ParticleFirefly(WorldClient.EMPTY_WORLD, this.rand.nextFloat() - 0.5f, this.rand.nextFloat() - 0.5f, 0, 0, 0, 0, 0);
+            fx.noPhysics = true;
+            fx.setAge(this.rand.nextInt(20));
             this.fireflies.add(fx);
-		}
+        }
         this.lastTick = System.currentTimeMillis();
-	}
+    }
 
-	@Override
-	public void render(@NotNull final Tessellator tessellator, @NotNull final MobFireflyCluster parent, final double x, final double y, final double z, final float yaw, final float partialTick) {
-		// Fireflies are rendered as particles which are spawned in the entity class
-	}
+    @Override
+    public void render(@NotNull final TessellatorGeneral tessellator, @NotNull final MobFireflyCluster parent, final double x, final double y, final double z, final float yaw, final float partialTick) {
+        // Fireflies are rendered as particles which are spawned in the entity class
+    }
 
-	@Override
-	public void renderPreview(@NotNull final Tessellator tessellator, @NotNull final MobFireflyCluster entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
-		super.renderPreview(tessellator, entity, x, y, z, yaw, partialTick);
+    @Override
+    public void renderPreview(@NotNull final TessellatorGeneral tessellator, @NotNull final MobFireflyCluster entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+        super.renderPreview(tessellator, entity, x, y, z, yaw, partialTick);
 
-		final long currentTick = System.currentTimeMillis();
-		final int storedTicks = (int) ((currentTick - this.lastTick) / 50.0f);
+        final long currentTick = System.currentTimeMillis();
+        final int storedTicks = (int) ((currentTick - this.lastTick) / 50.0f);
 
-		GL11.glPushMatrix();
-		GL11.glTranslatef(0, 0.75f, 0);
-		GL11.glEnable(GL11.GL_TEXTURE_2D);
-		GL11.glEnable(GL11.GL_BLEND);
-		Lighting.disable();
-		TextureRegistry.particleAtlas.bind();
-		final Tessellator t = Tessellator.instance;
-		t.startDrawingQuads();
-		for (int i = 0; i < this.fireflies.size(); i++) {
-			final ParticleFirefly firefly = this.fireflies.get(i);
-			firefly.renderParticleInGui(t, partialTick);
-			for (int j = 0; j < storedTicks; j++) {
-				firefly.tickGui();
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate(0, 0.75f, 0);
+        GLRenderer.enableState(State.BLEND);
+        Lighting.disable();
+        TextureRegistry.worldAtlas.bind();
+        final TessellatorGeneral t = GLRenderer.getTessellator();
+        t.startDrawingQuads();
+        for (int i = 0; i < this.fireflies.size(); i++) {
+            final ParticleFirefly firefly = this.fireflies.get(i);
+            firefly.renderParticleInGui(t, partialTick);
+            for (int j = 0; j < storedTicks; j++) {
+                firefly.tickGui();
                 this.lastTick = currentTick;
-			}
-			if (firefly.removed) {
+            }
+            if (firefly.removed) {
                 this.fireflies.remove(i);
-				i--;
-			}
-		}
-		t.draw();
-		GL11.glEnable(GL11.GL_CULL_FACE);
-		GL11.glPopMatrix();
+                i--;
+            }
+        }
+        t.draw();
+        GLRenderer.enableState(State.CULL_FACE);
+        GLRenderer.popFrame();
 
-		if (this.fireflies.size() < 20) {
-			for (int i = this.fireflies.size(); i < 20; i++) {
-				if (this.rand.nextInt(4) == 0) continue;
-				final ParticleFirefly fx = new ParticleFirefly(WorldClient.EMPTY_WORLD, this.rand.nextFloat() - 0.5f, this.rand.nextFloat() - 0.5f, 0, 0, 0, 0, entity.getColor().getId());
-				fx.noPhysics = true;
-				fx.setAge(this.rand.nextInt(20));
+        if (this.fireflies.size() < 20) {
+            for (int i = this.fireflies.size(); i < 20; i++) {
+                if (this.rand.nextInt(4) == 0) continue;
+                final ParticleFirefly fx = new ParticleFirefly(WorldClient.EMPTY_WORLD, this.rand.nextFloat() - 0.5f, this.rand.nextFloat() - 0.5f, 0, 0, 0, 0, entity.getColor().getId());
+                fx.noPhysics = true;
+                fx.setAge(this.rand.nextInt(20));
                 this.fireflies.add(fx);
-			}
-		}
-	}
+            }
+        }
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererGhast.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererGhast.java
index 441354d2f..926381e15 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererGhast.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererGhast.java
@@ -1,11 +1,11 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.monster.MobGhast;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.models.entity.BoneTransform;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
@@ -23,7 +23,9 @@ public class MobRendererGhast extends MobRenderer<MobGhast> {
         final BoneTransform body = model.getTransform("body");
 
         float charge = MathHelper.lerp(entity.attackChargeO, entity.attackCharge, partialTick) / 20F;
-        if(charge < 0.0F) { charge = 0.0F; }
+        if (charge < 0.0F) {
+            charge = 0.0F;
+        }
         charge = 1.0F / (charge * charge * charge * charge * charge * 2.0F + 1.0F);
         final float sHeight = (8F + charge) / 2.0F;
         final float sWidth = (8F + 1.0F / charge) / 2.0F;
@@ -48,10 +50,11 @@ public class MobRendererGhast extends MobRenderer<MobGhast> {
     }
 
     @Override
-    public void renderPreview(@NotNull final Tessellator tessellator, @NotNull final MobGhast mobGhast, final double x, final double y, final double z, final float yaw, final float partialTick) {
-        GL11.glPushMatrix();
-        GL11.glScalef(0.25f, 0.25f, 0.25f);
+    public void renderPreview(@NotNull final TessellatorGeneral tessellator, @NotNull final MobGhast mobGhast, final double x, final double y, final double z, final float yaw, final float partialTick) {
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate(0, 1f, 0f);
+        GLRenderer.modelM4f().scale(0.25f, 0.25f, 0.25f);
         super.renderPreview(tessellator, mobGhast, x, y, z, yaw, partialTick);
-        GL11.glPopMatrix();
+        GLRenderer.popFrame();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererGiant.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererGiant.java
index 3912d9bbc..c179f9e7c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererGiant.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererGiant.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.core.entity.monster.MobZombie;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
 
 public class MobRendererGiant extends MobRendererZombie
 {
@@ -17,7 +17,7 @@ public class MobRendererGiant extends MobRendererZombie
     @Override
     protected void preRenderTransform(@NotNull final MobZombie entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
         super.preRenderTransform(entity, x, y, z, yaw, partialTick);
-        GL11.glScalef(this.scale, this.scale, this.scale);
+        GLRenderer.modelM4f().scale(this.scale, this.scale, this.scale);
     }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererHuman.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererHuman.java
index a4abf18bf..7d72ad752 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererHuman.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererHuman.java
@@ -1,41 +1,40 @@
 package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.PlayerSkinParser;
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.core.entity.monster.MobHuman;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
+import org.joml.Math;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
-public class MobRendererHuman extends MobRendererBiped<MobHuman>
-{
+public class MobRendererHuman extends MobRendererBiped<MobHuman> {
     public MobRendererHuman() {
         super(0.5f);
     }
 
     @Override
     protected void preRenderTransform(@NotNull final MobHuman entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
-        GL11.glTranslated(x, y, z);
-        GL11.glRotatef(-getBodyYaw(entity, partialTick) * MathHelper.RAD_TO_DEG, 0, 1, 0);
-        GL11.glScalef(1/ENTITY_RENDER_SCALE, 1/ENTITY_RENDER_SCALE, -1/ENTITY_RENDER_SCALE);
+        GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
+        GLRenderer.modelM4f().rotateY(-getBodyYaw(entity, partialTick));
+        GLRenderer.modelM4f().scale(1 / ENTITY_RENDER_SCALE, 1 / ENTITY_RENDER_SCALE, -1 / ENTITY_RENDER_SCALE);
 
         final float scale = 0.9375F;
-        GL11.glScalef(scale, scale, scale);
+        GLRenderer.modelM4f().scale(scale, scale, scale);
 
-        if(entity.deathTime > 0) {
+        if (entity.deathTime > 0) {
             float rotationProgress = (((entity.deathTime + partialTick) - 1.0F) / 20F) * 1.6F;
             rotationProgress = MathHelper.sqrt_float(rotationProgress);
-            if(rotationProgress > 1.0F) {
+            if (rotationProgress > 1.0F) {
                 rotationProgress = 1.0F;
             }
-            GL11.glRotatef(rotationProgress * getMaxDeathRotation(entity), 0.0F, 0.0F, 1.0F);
+            GLRenderer.modelM4f().rotateZ(Math.toRadians(rotationProgress * getMaxDeathRotation(entity)));
         }
     }
 
     @Override
-    public void loadEntityTexture(final @NotNull MobHuman entity)
-    {
+    public void loadEntityTexture(final @NotNull MobHuman entity) {
         bindDownloadableTexture(entity.skinUrl, entity.getEntityTexture(), entity.slimModel ? PlayerSkinParser.instanceAlex : PlayerSkinParser.instanceSteve);
     }
 
